﻿using System;
using System.Collections.Generic;

using DevExpress.XtraEditors;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Load                                     += Form_Load;
            this.categoryLookUpEdit.EditValueChanged += categoryLookUpEdit_EditValueChanged;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            List<Category> categorieList = Category.GetList();

            this.categoryLookUpEdit.Properties.KeyMember     = "Key";
            this.categoryLookUpEdit.Properties.DisplayMember = "CategoryName";
            this.categoryLookUpEdit.Properties.DataSource    = categorieList;

            List <Product> productList = Product.GetList();

            this.productLookUpEdit.CascadingOwner             = this.categoryLookUpEdit;
            this.productLookUpEdit.Properties.CascadingMember = "CategoryID";
            this.productLookUpEdit.Properties.KeyMember       = "ID";
            this.productLookUpEdit.Properties.DisplayMember   = "ProductName";
            this.productLookUpEdit.Properties.DataSource      = productList;
        }

        #endregion
        #region 카테고리 룩업 에디터 편집 값 변경시 처리하기 - categoryLookUpEdit_EditValueChanged(sender, e)

        /// <summary>
        /// 카테고리 룩업 에디터 편집 값 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void categoryLookUpEdit_EditValueChanged(object sender, EventArgs e)
        {
            this.productLookUpEdit.EditValue = null;
        }

        #endregion
    }
}