﻿using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// 제품
    /// </summary>
    public class Product
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ID - ID

        /// <summary>
        /// ID
        /// </summary>
        public int ID { get; set; }

        #endregion
        #region 카테고리 ID - CategoryID

        /// <summary>
        /// 카테고리 ID
        /// </summary>
        public int CategoryID { get; set; }

        #endregion
        #region 제품명 - ProductName

        /// <summary>
        /// 제품명
        /// </summary>
        public string ProductName { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 리스트 구하기 - GetList()

        /// <summary>
        /// 리스트 구하기
        /// </summary>
        /// <returns>리스트</returns>
        public static List<Product> GetList()
        {
            List <Product>  list = new List<Product>
            {
                new Product() { ID = 0, ProductName = "Chang"           , CategoryID = 0 },
                new Product() { ID = 1, ProductName = "Ipoh Coffee"     , CategoryID = 0 },
                new Product() { ID = 2, ProductName = "Ravioli Angelo"  , CategoryID = 1 },
                new Product() { ID = 3, ProductName = "Filo Mix"        , CategoryID = 1 },
                new Product() { ID = 4, ProductName = "Tunnbrod"        , CategoryID = 1 },
                new Product() { ID = 5, ProductName = "Konbu"           , CategoryID = 2 },
                new Product() { ID = 6, ProductName = "Boston Crab Meat", CategoryID = 2 }
            };

            return list;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString()

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <returns>문자열</returns>
        public override string ToString()
        {
            return $"Product object {{ CategoryID : {CategoryID}, ProductName : {ProductName} }}";
        }

        #endregion
    }
}